﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CKExpr;
using System.Data;

namespace CKPoolSet
{
    /// <summary>
    /// 数据库处理逻辑
    /// </summary>
    public class DBHandler : IDBHandler
    {
        DatabaseLgc access = new DatabaseLgc();

        /// <summary>
        /// 执行数据更新操作,返回影响数据的行数
        /// </summary>
        /// <param name="sql"></param>
        /// <returns></returns>
        public int Execute(string sql)
        {
            var _result = access.ExecSql(sql);
            return _result ? 1 : 0;
        }
        /// <summary>
        /// 执行数据更新操作,返回影响数据的行数
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="dicParameters"></param>
        /// <returns></returns>
        public int Execute(SqlWrapper sqlWrapper)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// 使用自定义Sql，传入相关变量，返回ExpressTable
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="dicParameters"></param>
        /// <returns></returns>
        public DataTable Query(SqlWrapper sqlWrapper)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// 使用自定义Sql，传入相关变量，返回ExpressTable
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public DataTable Query(string sql, params object[] parameters)
        {
            return access.GetTable(sql, parameters);
        }
        /// <summary>
        /// 更新实体及基础Sql集合 支持的更新操作对象包含：KeyValueItem[string, Dictionary[string, object]],KeyValueItem[string,
        /// ProcParameter[]],SetStyleEntity,IDictionaryService             
        /// </summary>
        /// <param name="enumerable"></param>
        /// <param name="tag"></param>
        /// <returns></returns>
        public List<SqlWrapper> UpdateEntities(List<SqlWrapper> sqlWrappers, object tag)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// 使用id发生器创新新的Id，以tableName为参数
        /// </summary>
        /// <param name="tableName"></param>
        /// <param name="tag"></param>
        /// <returns></returns>
        public string NewId(string tableName, SqlParams parameters, object tag)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// 使用id发生器创新新的Id，以tableName为参数
        /// </summary>
        /// <param name="tableName"></param>
        /// <param name="count"></param>
        /// <param name="tag"></param>
        /// <returns></returns>
        public List<string> NewId(string tableName, int count, SqlParams parameters, object tag)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// 执行任意参数并返回结果。
        /// </summary>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public object Invoke(params object[] parameters)
        {
            throw new NotImplementedException();
        }
        /// <summary>
        /// 开始数据库事务。
        /// </summary>
        public IDbTransaction BeginTransaction()
        {
            throw new NotImplementedException();
        }
    }
}
